/* Public domain 
   http://home.worldonline.cz/~cz210552/
   */

import java.util.*;
import javax.mail.*;

public class msgdel
{
 public static void main(String argz[]) throws javax.mail.MessagingException
 {
   System.out.println("Simple Message deleter by Radim Kolar, Public Domain.\n");
   if(argz.length<4)
   {
     System.out.println("usage: msgdel <protocol> <host> <user> <pass> [msgnum ...]");
     System.out.println("\nmsgnum can be also specified by range X-Y or list X,Y,Z");
     System.exit(2);
   }
   String protocol=argz[0];
   String host=argz[1];
   String user=argz[2];
   String password=argz[3];

   // get session
   Session session=Session.getDefaultInstance(System.getProperties(),null);

   // get store
   Store store=session.getStore(protocol);
   // connect to server
   System.out.println("Connecting to "+protocol+"://"+user+"@"+host+"/INBOX");
   try
    {
     store.connect(host,user,password);
    }
   catch (javax.mail.AuthenticationFailedException z)
    {
     System.out.println("Login failed. Bad password/username");
     System.exit(1);
    }
   System.out.println("\tConected & Loged in.");

   // open folder
   Folder folder=store.getDefaultFolder();
   folder=folder.getFolder("INBOX");
   folder.open(Folder.READ_WRITE);
   // get messages
   Message[] msgs=folder.getMessages();
   System.out.println("\tFolder INBOX opened with "+msgs.length+" messages, "+folder.getNewMessageCount()+" new.");
   if(argz.length>4 && msgs.length>0)
   {
   // scan argz and delete msgs.
   for(int i=4;i<argz.length;i++)
   {
    StringTokenizer st1;
    st1=new StringTokenizer(argz[i],",");
    while(st1.hasMoreElements())
    {
     StringTokenizer st2;
     st2=new StringTokenizer(st1.nextToken(),"-");
     
     if(st2.countTokens()==1)
      {
       int n;
       n=Integer.valueOf(st2.nextToken()).intValue();
       delete1(msgs,n);
      }
     else if(st2.countTokens()==2)
     {
      int n1=Integer.valueOf(st2.nextToken()).intValue();
      int n2=Integer.valueOf(st2.nextToken()).intValue();

      if(n1>n2) System.out.println("Invalid range "+n1+"-"+n2);
       else
        for (int z=n1;z<=n2;z++)
         delete1(msgs,z);
     } else System.out.println("Not a valid range: "+st2);
   } /* st1*/  
   } /* argz loop */
  } /* has argz */ 
  //close folder & Expunge
  folder.close(true);
  System.out.println("\tFolder closed.");
  //disconnect
  store.close();
  System.out.println("Disconnected.");
  System.exit(0);

 }


private final static void delete1(Message msgs[],int n) throws javax.mail.MessagingException
{
    Message m;
    if(n<1 || n>msgs.length)
     {
       System.out.println("Message number "+n+" is out of range.");
       return;
     }
    m=msgs[n-1];
    if(m.getMessageNumber()!=n)
    {
     System.out.println("BAD MSGNUM. Expected="+n+" Actual="+m.getMessageNumber());
      return;
    }
    System.out.println("Deleting msg #"+n);
    m.setFlag(Flags.Flag.DELETED,true);
}

}
